## live-ascii-camera 

利用HTML5将摄像头视频流转换成ascii码流，通过websocket实时传输给其它浏览器展示。服务端使用[workerman](http://www.workerman.net)

## 提示

最好用火狐测试，谷歌浏览器升级了安全策略，谷歌浏览器只能在https下才能利用html5打开摄像头。

##  说明
此想法来源于 [ascii-camera](https://github.com/idevelop/ascii-camera) 项目，live-ascii-camera在此项目的基础上增加了websocket实时传输功能，通过workerman转发给其它浏览器。


##  在线示例

1、摄像头录制页面 http://www.workerman.net/demos/live-ascii-camera/camera.html

2、实时接收ascii码视频流页面 http://www.workerman.net/demos/live-ascii-camera/


##  使用方法

1、下载 或者 ```git clone https://github.com/walkor/live-ascii-camera```

2、进入项目没目录，运行 ```composer install```

3、运行 php start.php start -d

4、录制摄像的页面为 http://127.0.0.1:8123/camera.html

5、接收视频流的页面为 http://127.0.0.1:8123/


## 界面示例
<pre id="ascii">
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@81;iG@88888801;888000GGit@@@GCLLC@@@@@C
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@81;iC8@888880f;f08880GGtiC@@GCLLLG@88@f
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@Li1L8@8@@@88C:i88@88GGG1i@@GLLLCL8@8@1
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@8@@@@@@@@@@@@@@@@@@@L1if8@@@@@@@G;,8@8880G0ft@@8CCLCCC@@@i
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@;       ..,,;i1fC8@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@C;;f888888880:,L8@800GGf1G@@@0CCGC0@@1
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@f                               ,:,i11fC@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@Gi;1888@@@888;,i8@888GGGtG@@@GGCCCG8@L
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@,                                                      .,;tLGG08@88@8@@@@@@@@@@@@@@@@@@@0iit@@8@88888L,:888880GGLf@@@CCCCCG0@f
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@i         ;1:,.                                                            .,ifftC8@@@@@@@1it@@8@88880L;:G80880GGLt@@@CCCCGGG@C
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@G          G0t1ii1iiiiii;;;;;;::,,,..                                                         .:;1tCC0GL;,t88000GGCf@@@CLCCCCCGC
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@;         :i                     .,,:;;;i;iiiiii;;;;;::,,..                                                .:itffL8@@@@CLCCCGCCC
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@0          1,                                          .,,:;;ii11111111ii;;;;::,..                              .:;;;,.     ..,:;
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@:         ,1                                                              .,:;i1ttfffffffftt111ii;::,,.           .,:;;:,.       
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@f          i:                                                                                .:;itfLGCGGGGGCCLLLftttt1ttft1;:,    
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@,         ,1                                                                                                .:;i1LG888@@@@@@880GC;
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@1          i:                                  .::.                                                                    .:;i1ffffLGi
@@@@@@@@@@@@@@@@@@@@@@@@@@@@8           i                               ;L8@@@@88@@@@@CfL80L1::                                                        .,:;;:,.;
@@@@@@@@@@@@@@@@@@@@@@@@@@@@,          ;:                            ;@@@@@@@@@@LttL@@@@CCG@@@G0Li                 ..                                    .,,::.,
@@@@@@@@@@@@@@@@@@@@@Cti;:,            i                            :G0@@@@GLG@@@@@CG@@@@@@8@@@@G8@,       .ii:..::.         ....,,,,,,,,,,..              ..,,,
@@@@@@@@@@@@@@@@@@88L11i1ti           :;                            it1ttC00ftLCG8@@CfC000888@@@@@@@t,    .if8@@@808@8@8000LCC:       ...    .,,::::         ...
@@@@@@@@@@@@@@@@@@@@@@@@@@t           i                             :tttt11ii1fCCCCC0@@@80@88@80008@@@G;;@@@@@@@@@@@@@@@88@@@@@t;.... ..                       .
@@@@@@@@@@@@@@@@@@@@@@@@@G           ,;                              Lfii;;itLC0@@@@@@@@@@0GGG08888@88@@@@@@@@@@@@@@0CC0@@@@@@@@@@@;.        ..  .              
@@@@@@@@@@@@@@@@@@@@@@@@@:           i.                              ;ft11ittfG@@@@@@@LfLCLfG@@@0LCL1itC@@@@@@@@@@@@@@@@@@@@@@@@@@@@@t,    .......              
@@@@@@@@@@@@@@@@@@@@@@@01           .i                          ,:1fLG0L1iiitLLLG8GCLL00fi,  :i,      ,1G@@@@8ffC008@@G0@@@@@@@@@@@@@@@,   ...  ...             
@@@@@@@@@@@@@@@@@@@@@@0f            i,                       .C@@@@@@@@0LiitttfffL0@@@G;.             .,,C@Li:,,,.  .::::i;,;1G@@@@@@@@@;. .   ..,. ..          
@@@@@@@@@@@@@@@@@@@@@8G;           .i                        L8888@@@@@@@LttLCC0@@@@@C;.,;:.           tG80t;;i1;,   .   .... .;L@@@@@@@@f,.    ......          
@@@@@@@@@@@@@@@@@@@@@@0,           ;:                        i8888@@@@@@8CffCCttC@@@f:,......         ,C@@01;;:,,          .    . G@@@@@@@8t,    .,...          
@@@@@@@@@@@@@@@@@@@@@@f            i                           .iG@@@@@8G8@8Ltttif8@01::t8@@@@@G,     .L@@@LG8@@@f:            ,;;,,t@@@@@@@GC;  .,...          
@@@@@@@@@@@@@@@@@@@@@@.           :;                         .,:itC@@@@@@@@@01;iiitC0Gfit@@@Ci:.        ,1LLG880@@@L.        .:::ii:;@@@@@@@;,,..,,,.   ..      
@@@@@@@@@@@@@@@@@@@@@t            i,                            ,1C8@@@@@@@@@L11ftf0GLt1i;:,.         ,:,iLt;::,..:,       :8@@@@@f11@@@@@@C:,,,,,,,..   .      
@@@@@@@@@@@@@@@@@@@@@.           ,i                               f0@@8080G8@0f1ffLCCLLti;:,,..      .;1tG000L111iitf11i;:,:itfG@@@@@@@@@@0:,,,..   .           
@@@@@@@@@@@@@@@@@@@@f            i:                              ,G@8CfG0@@@0L1itfLti10@81;,::::;;:,:,   L88@@LLGtifG00CC0LfC0G:,;ffffL8@8L1if@@@t,.            
@@@@@@@@@@@@@@@@@@@@,           ,1                               .tG@@@@@@@@@@GGG880G08@@@8L;;itCL.     .C0G8@f;;:iGG00ti;;:f@800Gfi;080GG0G;::;11:             
@@@@@@@@@@@@@@@@@@@L            i;                              ,G@@@@@@@@@@@@@@@@@@@88@@@@@8t1L@C,   :CGCLtC@f,  .:;LGCL:  1@CtCG00G8800CCG,   ..              
@@@@@@@@@@@@@@@@@@@,           .1,                                f@@88888@888@@@@@@@@@@@@@@@@@8@t   i0GCCCtL@C1tf1:,,,,11;,,0C1tGGG8@@88GC0L,.                 
@@@@@@@@@@@@@@@@@@t            ;1                                 t@@@@@@@@@@@@@@8@@@@@@@@@@@@@@@G:  t0GCCL110@Ct:.:LLftt1ff;C0fLCCCCG0888CG8;.                 
@@@@@@@@@@@@@@@@@@,            1;                               1G@@@@@@@@@@@@@@80G00GCC0@@@@@@@@@@t,1GGCCCf1t01   :C88@@1.  ,GGfCCCCG088@8081.                 
@@@@@@@@@@@@@@@@@t            :1.                            .L@@@@@@@@@@@@@@@@@@@@@80GGCC0@GLLtL@@@ttfCGGCftL@G;,,,f8@@@f.   t0ffCCGG088@@80C,                 
@@@@@@@@@@@@@@@@8.            i;                           .G008@@@@@@@@@@@@@@@@@@@@80000088CLLf;1f@8ftCCGGGCG@81;:.;8@@@01t1;t@0LCGGG8@888800f.                
@@@@@@@@@@@@@@@@1            ,1,                           .f@@0GGCC0@@888888@@@@@@@00GGCCCCCCCG, ;8@1,i00000G881    t@@@@t:;;i0@0GGG08@0CG00G0;             .. 
@@@@@@@@@@@@@@@0.            i1                            i@@@@@@0LL8@8@@8888@@@@@@80GCCCCCCCCC1if@@i  ,C000GG@C,   ;8@@@G,   :0@00888800088GCG:            .. 
@@@@@@@@@@@@@@@1            .t;                            ,C8@@@@8LftLLtfG@88@@@@@@0fii111tCCf1i,       :G800G@8i::,,t8@@@i....L@800888888@80G0L.              
@@@@@@@@@@@@@@0.            ;1.                             .i08@@@@008@0CLCC0@@@@@@01;;1i:;tfi::        iG0088@@L1ti.  .:ii1LL1C@888888@@80080G0;.             
@@@@@@@@@@@@@@1             ti                                  ,f00GCG@@@@88@@@@@@@8C1iii;1fLt;;.      .f0000088Ci,.     iLCCLCL8@@@@@@@80CLC000C,          .  
@@@@@@@@@@@@@@.            :t:                                       ..,;itttffG@@@@@@@8880000000;      ;G00GG0080f;:i11:..:i1ii:1CC88888880GffG01.         .  .
@@@@@@@@@@@@@t             i1                                                              ..,::;       :LCGCCGG00GLtfLLt,       .1tC88888880GGG0t,  .     ....,
@@@@@@@@@@@@@.            .t;                                                                                                    .,.;LG0088880CG00i....    .....
@@@@@@@@@@@@1             ;t,                                                                                                                                   
@@@@@@@@@@@L              11                                                                                                                                    
@@@@@@@888G:             ,1:                                                                                                                                    
88000000GG1                                                                                                                                                     
0GGGGGGGGL,                                                                                                                                                     
CGGCCCCCLi                                                                                                                                                      
CCLLLLLLf,                                                                                                                                                      
LLLLffffi                                                                                                                                                       
LfLLfffft;.                                                                                                                                                     
Lfffffffff11ii;;:::,,....                                                                                                                                       
fffffftfffft11iiiiiiiii1iiiiiiiiii1iiii;;;;;:::,,,,...                                                                                                          
ffttttttttftt1111i11111ttt1tttttttttttffffLLLCGG008@@@@@@@@@@@@@@@800GCCfftttii;;::,,,.                                                                         
fftfttttttttttt1ttffffffffffffffffffffffLLLCCGG008@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@8800GGGCCLCffffffftt11i1111i1i1i1ii1111111111111tttttf
ttttttttttttfLfLLGG8@@@@88800000GGGGGGGGGGGGG0008@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
</pre>
